var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { h } from '@stencil/core';
import { MapToComponentField, VegaSlimmer } from 'vega-slimmer/core';
/** This code snippet defines a TypeScript class named `VegaButtonLoadingRenderer` that extends `VegaSlimmer`. It includes several class properties (`loading`, `loadingMode`, `size`, `danger`) that are mapped to fields of a `VegaButton` component. The `render` method of this class is responsible for rendering a loading indicator component (`vega-loading-indicator`) based on the values of the class properties. */
export class VegaButtonLoadingRenderer extends VegaSlimmer {
  /**
   * renders a loading indicator component based on the values of certain properties (`loading`) of the class instance.
   *
   * @returns {Nullable<HTMLVegaLoadingIndicatorElement>} Loading element if the property loading set to true
   */
  render() {
    if (this.loading) {
      return h("vega-loading-indicator", { size: "micro", mode: "indeterminate" });
    }
  }
}
__decorate([
  MapToComponentField()
], VegaButtonLoadingRenderer.prototype, "loading", void 0);
